#define _GNU_SOURCE
#include <stdio.h>
#include <msgpack.h>
#include <stdlib.h>
#include <stdarg.h>

#include "utils.h"

int verbose;

const char* to_v6_subnet(const char* ip) {
    static char buffer[45]; // Enough to hold IPv6/64 + 0x00 + few spare bytes
    if(strchr(ip,'/') != NULL)
        return ip;
    snprintf(buffer, 45, "%s/64", ip);
    return buffer;
}

bool is_ipv6(const char* addr) {
    return strchr(addr, ':') != NULL;
}

int systemf(const char *fmt, ...) {
    va_list ap;
    int ret = 0;
    char *buff = NULL;
    size_t sz = 0;

    // Create a buffer, construct command and run it
    va_start(ap, fmt);
    vasprintf(&buff, fmt, ap);
    assert(buff != NULL);
    ret = system(buff);
    va_end(ap);
    free(buff);
    return ret;
}

void set_msgpack_string(char *buff, size_t len, msgpack_object_str *msg) {
    size_t sz = (msg->size + 1) > len ? len : msg->size + 1;
    snprintf(buff, sz, "%s", msg->ptr);
    buff[sz] = 0;
}
